Index: Python-2.7.9/Doc/howto/urllib2.rst
===================================================================
--- Python-2.7.9.orig/Doc/howto/urllib2.rst
+++ Python-2.7.9/Doc/howto/urllib2.rst
@@ -523,6 +523,11 @@ setting up a `Basic Authentication`_ han
     through a proxy.  However, this can be enabled by extending urllib2 as
     shown in the recipe [#]_.
 
+.. note::
+
+    ``HTTP_PROXY`` will be ignored if a variable ``REQUEST_METHOD`` is set; see
+    the documentation on :func:`~urllib.getproxies`.
+
 
 Sockets and Layers
 ==================
Index: Python-2.7.9/Doc/library/urllib.rst
===================================================================
--- Python-2.7.9.orig/Doc/library/urllib.rst
+++ Python-2.7.9/Doc/library/urllib.rst
@@ -289,6 +289,15 @@ Utility functions
    Mac OS X and Windows Systems Registry for Windows.
 
 .. note::
+
+    If the environment variable ``REQUEST_METHOD`` is set, which usually
+    indicates your script is running in a CGI environment, the environment
+    variable ``HTTP_PROXY`` (uppercase) will be ignored. This is because that
+    variable can be injected by a client using the "Proxy:" HTTP header. If you
+    need to use an HTTP proxy in a CGI environment, either use ``ProxyHandler``
+    explicitly, or make sure the variable name is in lowercase (``http_proxy``).
+
+.. note::
     urllib also exposes certain utility functions like splittype, splithost and
     others parsing url into various components. But it is recommended to use
     :mod:`urlparse` for parsing urls than using these functions directly.
Index: Python-2.7.9/Doc/library/urllib2.rst
===================================================================
--- Python-2.7.9.orig/Doc/library/urllib2.rst
+++ Python-2.7.9/Doc/library/urllib2.rst
@@ -224,6 +224,11 @@ The following classes are provided:
 
    To disable autodetected proxy pass an empty dictionary.
 
+.. note::
+
+   ``HTTP_PROXY`` will be ignored if a variable ``REQUEST_METHOD`` is set; see
+   the documentation on :func:`~urllib.getproxies`.
+
 
 .. class:: HTTPPasswordMgr()
 
Index: Python-2.7.9/Lib/test/test_urllib.py
===================================================================
--- Python-2.7.9.orig/Lib/test/test_urllib.py
+++ Python-2.7.9/Lib/test/test_urllib.py
@@ -161,6 +161,19 @@ class ProxyTests(unittest.TestCase):
         self.env.set('NO_PROXY', 'localhost, anotherdomain.com, newdomain.com')
         self.assertTrue(urllib.proxy_bypass_environment('anotherdomain.com'))
 
+    def test_proxy_cgi_ignore(self):
+        try:
+            self.env.set('HTTP_PROXY', 'http://somewhere:3128')
+            proxies = urllib.getproxies_environment()
+            self.assertEqual('http://somewhere:3128', proxies['http'])
+            self.env.set('REQUEST_METHOD', 'GET')
+            proxies = urllib.getproxies_environment()
+            self.assertNotIn('http', proxies)
+        finally:
+            self.env.unset('REQUEST_METHOD')
+            self.env.unset('HTTP_PROXY')
+
+
 
 class urlopen_HttpTests(unittest.TestCase, FakeHTTPMixin):
     """Test urlopen() opening a fake http connection."""
Index: Python-2.7.9/Lib/urllib.py
===================================================================
--- Python-2.7.9.orig/Lib/urllib.py
+++ Python-2.7.9/Lib/urllib.py
@@ -1373,11 +1373,28 @@ def getproxies_environment():
     [Fancy]URLopener constructor.
 
     """
+    # Get all variables
     proxies = {}
     for name, value in os.environ.items():
         name = name.lower()
         if value and name[-6:] == '_proxy':
             proxies[name[:-6]] = value
+
+    # CVE-2016-1000110 - If we are running as CGI script, forget HTTP_PROXY
+    # (non-all-lowercase) as it may be set from the web server by a "Proxy:"
+    # header from the client
+    # If "proxy" is lowercase, it will still be used thanks to the next block
+    if 'REQUEST_METHOD' in os.environ:
+        proxies.pop('http', None)
+
+    # Get lowercase variables
+    for name, value in os.environ.items():
+        if name[-6:] == '_proxy':
+            name = name.lower()
+            if value:
+                proxies[name[:-6]] = value
+            else:
+                proxies.pop(name[:-6], None)
     return proxies
 
 def proxy_bypass_environment(host):
